package nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.visitor;

import com.fasterxml.jackson.annotation.JsonMerge;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.OptBoolean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.SneakyThrows;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.ClientMethodDefinition;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.SignalRHubClassVisitor;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.visitor.TestClass.SomeNestableAnnotation;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.asm.visitor.TestClass.SomeNestableAnnotationAgain;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.helper.JandexReflectionHelper;
import nl.rug.digitallab.quarkus.signalr.extension.deployment.util.ApprovalTestsClassDisplayer;
import nl.rug.digitallab.quarkus.signalr.extension.runtime.annotations.ClientMethod;
import nl.rug.digitallab.quarkus.signalr.extension.runtime.session.SignalRSession;
import org.approvaltests.Approvals;
import org.jboss.jandex.Index;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.commons.ClassRemapper;
import org.objectweb.asm.commons.Remapper;

import java.io.IOException;
import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.Parameter;
import java.util.List;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.*;

class SignalRHubClassVisitorTests {
    private Set<ClientMethodDefinition> methodDefinitions;

    /**
     * Renames the class to avoid conflicts during testing.
     *
     * @param mutatedBytecode - The bytecode to rename
     * @return - The renamed bytecode
     */
    private static byte[] getBytecodeWithRenamedClass(byte[] mutatedBytecode) {
        ClassReader reader = new ClassReader(mutatedBytecode);
        ClassWriter writer = new ClassWriter(reader, ClassWriter.COMPUTE_FRAMES);
        ClassRemapper adapter = new ClassRemapper(writer, new Remapper() {
            @Override
            public String map(String internalName) {
                if (internalName.equals(TestClass.class.getName().replace(".", "/"))) {
                    return internalName + "Generated";
                }
                return internalName;
            }
        });
        reader.accept(adapter, ClassReader.EXPAND_FRAMES);

        return writer.toByteArray();
    }

    @BeforeEach
    void collectMethodDefinitions() throws IOException {
        Index index = Index.of(TestClass.class);
        this.methodDefinitions = JandexReflectionHelper.extractClientMethodsFrom(index.getClassByName(TestClass.class));

        assertTrue(!methodDefinitions.isEmpty());
    }

    private byte[] generateBytecodeWithAppliedVisitor() throws IOException {
        ClassReader reader = new ClassReader(TestClass.class.getName());
        ClassWriter writer = new ClassWriter(reader, ClassWriter.COMPUTE_FRAMES);

        SignalRHubClassVisitor visitor = new SignalRHubClassVisitor(writer, methodDefinitions);
        reader.accept(visitor, ClassReader.EXPAND_FRAMES);

        byte[] mutatedClass = writer.toByteArray();
        assertNotNull(mutatedClass);

        return mutatedClass;
    }

    private Class<?> loadClassInDisposableClassLoader() throws IOException, ClassNotFoundException {
        byte[] mutatedBytecode = generateBytecodeWithAppliedVisitor();

        // Rename the class to avoid conflicts
        byte[] renamedBytecode = getBytecodeWithRenamedClass(mutatedBytecode);

        // Load the class
        ClassLoader loader = new ClassLoader() {
            @Override
            public Class<?> loadClass(String name) throws ClassNotFoundException {
                if (name.equals(TestClass.class.getName() + "Generated")) {
                    return defineClass(name, renamedBytecode, 0, renamedBytecode.length);
                }

                return super.loadClass(name);
            }
        };

        Class<?> clazz = loader.loadClass(TestClass.class.getName() + "Generated");
        assertNotNull(clazz);
        return clazz;
    }

    @Test
    @DisplayName("Approval test for the bytecode generated by the SignalRHubClassVisitor")
    void approvalTestBytecode() throws IOException {
        byte[] mutatedBytecode = generateBytecodeWithAppliedVisitor();

        String displayedBytecode = ApprovalTestsClassDisplayer.displayClass(mutatedBytecode);

        Approvals.verify(displayedBytecode);
    }

    @Test
    @DisplayName("Ensure that the bytecode generated by the SignalRHubClassVisitor is valid")
    @SneakyThrows(ReflectiveOperationException.class)
    void testSignalRHubClassVisitor() throws IOException {
        Class<?> clazz = loadClassInDisposableClassLoader();

        // Ensure that the class is not abstract
        assertEquals(0, clazz.getModifiers() & Modifier.ABSTRACT);

        // Ensure that the class has the correct methods
        for (ClientMethodDefinition method : methodDefinitions) {
            Method classMethod = clazz.getDeclaredMethod(method.getName(), SignalRSession.class);

            assertNotNull(classMethod);

            // Ensure that the method is not abstract
            assertEquals(0, classMethod.getModifiers() & Modifier.ABSTRACT);
        }
    }

    @Test
    @DisplayName("Ensure method annotations are kept after generation")
    @SneakyThrows(ReflectiveOperationException.class)
    void testMethodAnnotations() throws IOException {
        Class<?> clazz = loadClassInDisposableClassLoader();

        Method method = clazz.getMethod("someMethodWithAnnotations", SignalRSession.class);

        for (Class<? extends Annotation> t : List.of(ClientMethod.class, JsonProperty.class,
                JsonMerge.class, SomeNestableAnnotation.class, SomeNestableAnnotationAgain.class, JsonSerialize.class)) {
            assertNotNull(method.getAnnotation(t));
        }

        // Validate properties
        assertEquals("someMethodWithAnnotations", method.getAnnotation(JsonProperty.class).value());
        assertEquals("someDefaultValue", method.getAnnotation(JsonProperty.class).defaultValue());

        assertEquals(OptBoolean.DEFAULT, method.getAnnotation(JsonMerge.class).value());

        assertEquals(5, method.getAnnotation(SomeNestableAnnotation.class).value());
        assertArrayEquals(new int[]{1, 2, 3}, method.getAnnotation(SomeNestableAnnotation.class).intValues());

        SomeNestableAnnotationAgain nested = method.getAnnotation(SomeNestableAnnotationAgain.class);
        assertNotNull(nested);
        assertEquals(0, nested.arrays().length);

        SomeNestableAnnotation value = nested.value();
        assertNotNull(value);
        assertEquals(10, value.value());
        assertArrayEquals(new int[]{4, 5, 6}, value.intValues());

        assertEquals(String.class, method.getAnnotation(JsonSerialize.class).as());
    }


    @Test
    @DisplayName("Ensure parameter annotations on the method are kept after generation")
    @SneakyThrows(ReflectiveOperationException.class)
    void handleAnnotations() throws IOException {
        Class<?> clazz = loadClassInDisposableClassLoader();
        Method method = clazz.getMethod("someMethodWithAnnotations", SignalRSession.class);

        // Check the parameter for the expected annotations
        Parameter param = method.getParameters()[0];
        SomeNestableAnnotation nestableAnnotation = param.getAnnotation(SomeNestableAnnotation.class);
        assertNotNull(nestableAnnotation);

        assertEquals(5, nestableAnnotation.value());
        assertArrayEquals(new int[]{1, 2, 3}, nestableAnnotation.intValues());

        SomeNestableAnnotationAgain nestedAgain = param.getAnnotation(SomeNestableAnnotationAgain.class);
        assertNotNull(nestedAgain);

        assertEquals(10, nestedAgain.value().value());
        assertArrayEquals(new int[]{4, 5, 6}, nestedAgain.value().intValues());

        SomeNestableAnnotation[] arrays = nestedAgain.arrays();
        assertEquals(2, arrays.length);
        assertEquals(15, arrays[0].value());
        assertArrayEquals(new int[]{7, 8, 9}, arrays[0].intValues());
        assertEquals(20, arrays[1].value());
        assertEquals(0, arrays[1].intValues().length);
    }
}
